#ifndef INCLUDE__ScriptingDock_hxx
#define INCLUDE__ScriptingDock_hxx
#include "gui/qt.hxx"
#include <libguile.h>
#include <log4cxx/logger.h>

class ScriptingDock : public QDockWidget {
	Q_OBJECT

public:
	ScriptingDock(const QString& title, QWidget * parent = 0)
		: QDockWidget(title, parent)
		, logger(log4cxx::Logger::getLogger("ScriptingDock")) {     
		QTabWidget * tab = new QTabWidget;
		QWidget * widget = new QWidget;
		widget->setLayout(layout = new QGridLayout);
		layout->addWidget(browser = new QTextBrowser, 0, 0, 1, 0);
		layout->addWidget(line = new QLineEdit, 1, 0);
		layout->addWidget(button = new QPushButton(tr("Evaluate")), 1, 1);
		tab->addTab(widget, "GUILE");
		((QDockWidget*)this)->setWidget(tab);
		connect(button, SIGNAL(released()), this, SLOT(doEvaluate()));
		connect(line, SIGNAL(returnPressed()), this, SLOT(doEvaluate()));
		scm_init_guile();
		guile_output_port = scm_open_output_string();
		guile_error_port = scm_open_output_string();
		scm_set_current_output_port(guile_output_port);
		scm_set_current_error_port(guile_error_port);
	}
private:
	log4cxx::LoggerPtr logger;

	QTextBrowser * browser;
	QGridLayout * layout;
	QPushButton * button;
	QLineEdit * line;

	SCM guile_output_port;
	SCM guile_error_port;
private Q_SLOTS:
	void doEvaluate();
};

#endif
